from pile import Pile

def verifie_par(s):
    pile = Pile()
    for c in s:
        if c in [ '<', '{', '(', '[']:
            pile.empiler(c)
        elif pile.est_vide():
            # On a lu une parenthèse fermante
            # mais la pile est vide, mal parenthésé
            return False
        else:
            v = pile.depiler()
            if v == '(' and c != ')' or  \
               v == '[' and c != ']' or \
               v == '{' and c != '}' or \
               v == '<' and c != '>':
               # la parenthèse ouvrante au sommet
               # ne correspond pas à la parenthèse fermante lue
               return False

    #Après la boucle, s'il reste des choses sur la pile, alors
    # on n'a pas tout refermé. Si la pile est vide, le mot est correctement
    #parenthésé
    return pile.est_vide()
               
print(verifie_par("<<{()}>[]>")) # True
print(verifie_par("<((")) # False
print(verifie_par("<<{()}>[]>))")) # False
