from liste import Cellule

class File:

    def __init__(self):
        self.tete = None
        self.queue = None

    def ajouter(self, v):
        if self.queue is None:
            self.queue = Cellule(v, None)
            self.tete = self.queue
        else:
            self.queue.suivant = Cellule(v, None)
            self.queue = self.queue.suivant

    def retirer(self):
        v = self.tete.valeur
        if self.tete.suivant is None:
            self.queue = None
        self.tete = self.tete.suivant
        return v

    def est_vide(self):
        return self.tete is None
