from liste import Liste

#On utilise de l'héritage

class Pile(Liste):

    def __init__(self):
        super().__init__()

    def empiler(self, v):
        self.ajoute(v)

    def depiler(self):
        return self.retire()


class PileT:
    """Implémentation directe d'une pile utilisant un tableau Python"""

    def __init__(self):
        self.pile = []

    def est_vide(self):
        return len (self.pile) == 0

    def empiler(self, v):
        self.pile.append(v)

    def depiler(self):
        return self.pile.pop()
